<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/convert_dial_message_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>02/08/84  convert_dial_message_
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>The convert_dial_message_ subroutine is used in conjunction with the
<span id="L4" class="LineNr"> 4 </span>dial_manager_ subroutine to control dialed terminals.  It converts an
<span id="L5" class="LineNr"> 5 </span>event message received from the answering service over a dial control
<span id="L6" class="LineNr"> 6 </span>event channel into status information more easily used by the user.
<span id="L7" class="LineNr"> 7 </span>
<span id="L8" class="LineNr"> 8 </span>
<span id="L9" class="LineNr"> 9 </span>Entry points in convert_dial_message_:
<span id="L10" class="LineNr">10 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L11" class="LineNr">11 </span>
<span id="L12" class="LineNr">12 </span>
<span id="L13" class="LineNr">13 </span>:Entry:  return_io_module:
<span id="L14" class="LineNr">14 </span>02/08/84 convert_dial_message_$return_io_module
<span id="L15" class="LineNr">15 </span>
<span id="L16" class="LineNr">16 </span>
<span id="L17" class="LineNr">17 </span>Function: processes event messages from the answering service
<span id="L18" class="LineNr">18 </span>regarding the status of a dialed terminal or an auto call line.  In
<span id="L19" class="LineNr">19 </span>addition to returning line status, this entry point also returns the
<span id="L20" class="LineNr">20 </span>device name and I/O module name for use in attaching the line through
<span id="L21" class="LineNr">21 </span>the iox_ subroutine.
<span id="L22" class="LineNr">22 </span>
<span id="L23" class="LineNr">23 </span>
<span id="L24" class="LineNr">24 </span>Syntax:
<span id="L25" class="LineNr">25 </span>declare convert_dial_message_$return_io_module entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L26" class="LineNr">26 </span>     char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> 1 aligned<span class="textRainbow_lv0_o0">,</span> 2 bit<span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span> unal<span class="textRainbow_lv0_o0">,</span> 2 bit<span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span>
<span id="L27" class="LineNr">27 </span>     unal<span class="textRainbow_lv0_o0">,</span> 2 bit<span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span> unal<span class="textRainbow_lv0_o0">,</span> 2 bit<span class="textRainbow_lv1_p0">(</span>33<span class="textRainbow_lv1_p0">)</span> unal<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L28" class="LineNr">28 </span>call convert_dial_message_$return_io_module <span class="textRainbow_lv0_p0">(</span>message<span class="textRainbow_lv0_o0">,</span> channel_name<span class="textRainbow_lv0_o0">,</span>
<span id="L29" class="LineNr">29 </span>     io_module<span class="textRainbow_lv0_o0">,</span> n_dialed<span class="textRainbow_lv0_o0">,</span> flags<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L30" class="LineNr">30 </span>
<span id="L31" class="LineNr">31 </span>
<span id="L32" class="LineNr">32 </span>Arguments:
<span id="L33" class="LineNr">33 </span>message
<span id="L34" class="LineNr">34 </span>   is the event message to be decoded.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L35" class="LineNr">35 </span>channel_name
<span id="L36" class="LineNr">36 </span>   is the name of the channel that has dialed up or hung up.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L37" class="LineNr">37 </span>io_module
<span id="L38" class="LineNr">38 </span>   is the name of the iox_ I/O module to be used with the assigned
<span id="L39" class="LineNr">39 </span>   device.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L40" class="LineNr">40 </span>n_dialed
<span id="L41" class="LineNr">41 </span>   is the number of terminals currently dialed to the process or -1.
<span id="L42" class="LineNr">42 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L43" class="LineNr">43 </span>
<span id="L44" class="LineNr">44 </span>
<span id="L45" class="LineNr">45 </span>flags
<span id="L46" class="LineNr">46 </span>   is a bit string of the following structure:  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L47" class="LineNr">47 </span>      dcl 1 flags        aligned,
<span id="L48" class="LineNr">48 </span>            2 dialed_up  bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L49" class="LineNr">49 </span>            2 hung_up    bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L50" class="LineNr">50 </span>            2 control    bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L51" class="LineNr">51 </span>            2 pad        bit<span class="textRainbow_lv0_p0">(</span>33<span class="textRainbow_lv0_p0">)</span> unal;
<span id="L52" class="LineNr">52 </span>   Only the first three bits have meaning, and only one can be on at a
<span id="L53" class="LineNr">53 </span>   time.  See &quot;Notes&quot; below.
<span id="L54" class="LineNr">54 </span>code
<span id="L55" class="LineNr">55 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L56" class="LineNr">56 </span>
<span id="L57" class="LineNr">57 </span>
<span id="L58" class="LineNr">58 </span>Notes:  The message may be either a control message or an informative
<span id="L59" class="LineNr">59 </span>message.  Informative messages have flags.control off <span class="textRainbow_lv0_p0">(</span>&quot;0&quot;b<span class="textRainbow_lv0_p0">)</span>, n_dialed
<span id="L60" class="LineNr">60 </span>is set to -1, channel is set to the name of the channel involved,
<span id="L61" class="LineNr">61 </span>io_module is set to the name of an I/O module, and either
<span id="L62" class="LineNr">62 </span>flags.dialed_up or flags.hung_up is on, indicating that the named
<span id="L63" class="LineNr">63 </span>channel has either just dialed up or just hung up.
<span id="L64" class="LineNr">64 </span>
<span id="L65" class="LineNr">65 </span>Control messages have flags.control on <span class="textRainbow_lv0_p0">(</span>&quot;1&quot;b<span class="textRainbow_lv0_p0">)</span>, and n_dialed is set to
<span id="L66" class="LineNr">66 </span>the number of dialed terminals or -1.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
